.gba
.open "MF_U.gba","MF_U_EventSpriteOne5D.gba",0x8000000

;本asm由sapphy编写，由黑糊嘿呼（Heyhooheyhoo)翻译

/* 内存地图: https://tinyurl.com/sjj6ms4
事件表: https://tinyurl.com/woekqcu */

.definelabel CurrSpriteData,0x30006BC
.definelabel EventCounter,0x3000B87
.definelabel SamusBeam,0x300131A
.definelabel SamusMisBomb,0x300131B
.definelabel SamusSuitMisc,0x300131C
.definelabel SecurityLevelStat,0x300131D
.definelabel YourEvent,xxh 		; 把xx改成你想要的事件的数值

; 当前使用的精灵是5D，你可以在MAGE的“Sprite Editor”找到你想要的AI地址，并把该地址减一得到.org后面的值
.org 0x80339BC	; biospark的敌人的代码
	ldr     r2,=CurrSpriteData
	mov     r1,r2
	add     r1,24h
	ldrb    r0,[r1]
	cmp     r0,1
	beq     @@Pose1
	ldrh    r0,[r2]
	mov     r1,4
	orr     r0,r1
	strh    r0,[r2]				; 精灵不出现
	mov     r1,r2
	add     r1,25h
	mov     r0,0
	strb    r0,[r1]				; 设置碰撞体积为0
	sub     r1,1
	mov     r0,1
	strb    r0,[r1]				; 设置pose为0
	b       @@Return
@@Pose1:
; 比较简单的调试方法就是用No$Gba，如果你使用的是默认的精灵5D，断点的位置应该在80339E0
; 你可以把任何一个你想要用的部分删去“/*”“*/”
; 部分1：这个部分可以检测光束数据
/*	ldr   	r0,=SamusBeam		
	ldrb	r0,[r0]				
	cmp		r0,xxh				; xx是你想检测的光束的数据码，检测当前的光束数据是否等于检测值
	bne		@@Return			; 如果不等于就跳转至“返回”
	b     	@@SetEvent			; 跳转至“设置事件”的代码
*/
; 部分2：这个部分可以检测导弹和炸弹的数据
/*	ldr   	r0,=SamusMisBomb		
	ldrb	r0,[r0]           	
	cmp		r0,yyh				; yy是你想检测的导弹和炸弹的数据码，检测当前的导弹和炸弹数据是否等于检测值
	bne		@@Return			
	b     	@@SetEvent */	
; 部分3：这个部分可以检测服装和杂项的数据
/*	ldr   	r0,=SamusSuitMisc  	
	ldrb	r0,[r0]             
	cmp		r0,zzh				; zz是你想检测的服装和杂项的数据码，检测当前的服装和杂项数据是否等于检测值
	bne		@@Return			
	b     	@@SetEvent */
; 部分4：这个部分可以检测安全锁等级的数据
/*	ldr   	r0,=SecurityLevelStat  	
	ldrb	r0,[r0]             
	cmp		r0,xyh				; xy是你想检测的安全锁等级的数据码，检测当前的安全锁等级数据是否等于检测值
	bne		@@Return			; 没有@@SetEvent是因为他已经在下一行了
*/
@@SetEvent:
	ldr		r1,=EventCounter
	mov		r2,YourEvent
	strb	r2,[r1]
	; 删除该精灵
	ldr   r0,=CurrSpriteData
	mov   r1,0
	strh  r1,[r0]				; 设置敌人状态为0
@@Return:						
	bx      r14
	.pool

.close